var m_button;
var m_inited = false;
var m_prefs;
var rldyn = null;
var bundle = srGetStrBundle("chrome://imgsh/locale/imgsh.properties");
var imgNode;

var img_load_set = "permissions.default.image";
var img_all_load = 1;
var img_othersv_no_load = 3;
var img_no_load = 2;

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is SpellBound code.
 *
 * The Initial Developer of the Original Code is
 * Robert Strong <moz@exchangecode.com>.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Frank DeLicce (Ausdilicce) - used with his permission
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function initSetting()
{
	m_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	rldyn = m_prefs.getIntPref("imgsh.rldyn");
	rldef = m_prefs.getIntPref("imgsh.rldef");

	switch (rldyn){
		case 0 :
			document.getElementById('rld').checked = false;
			document.getElementById('rld2').checked = false;
			break;
		case 1 :
			document.getElementById('rld').checked = true;
			document.getElementById('rld2').checked = false;
			break;
		case 2 :
			document.getElementById('rld').checked = false;
			document.getElementById('rld2').checked = true;
			break;
		case 3 :
			document.getElementById('rld').checked = true;
			document.getElementById('rld2').checked = true;
			break;
		default :
			document.getElementById('rld').checked = false;
			document.getElementById('rld2').checked = false;
			break;
	}

	document.getElementById('rld3').value = rldef;
}

function imgsh_switchyn()
{
	if (document.getElementById('rld').checked){
		rldyns1 = 1;
	}else{
		rldyns1 = 0;
	}
	if (document.getElementById('rld2').checked){
		rldyns2 = 2;
	}else{
		rldyns2 = 0;
	}





	rldeff = document.getElementById('rld3').value;
	m_prefs.setIntPref("imgsh.rldyn", rldyns1+rldyns2);
	m_prefs.setIntPref("imgsh.rldef", rldeff);

}

function imgsh_switchimg()
{
	var nCurImgType = m_prefs.getIntPref(img_load_set);
	if (nCurImgType == img_no_load){
		imgsh_setShow("net");
	}else if(
		(nCurImgType == img_all_load) ||
		(nCurImgType == img_othersv_no_load)
	){
		imgsh_setHide("net");
	}
}



function imgsh_init()
{
	if (!m_inited){
		m_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		m_inited = true;
	}

	chk_pref();

	var nCurImgType = m_prefs.getIntPref(img_load_set);

	if (!m_prefs.prefHasUserValue("imgsh.rldyn")){
			m_prefs.setIntPref("imgsh.rldyn", 2);
		}

	if (!m_prefs.prefHasUserValue("imgsh.rldef")){
		var whichload;
		if (nCurImgType == img_all_load){
			whichload = 0;
		}
		if (nCurImgType == img_othersv_no_load){
			whichload = 1;
		}
		if (nCurImgType == img_no_load){
			whichload = 0;
		}
		m_prefs.setIntPref("imgsh.rldef", whichload);
	}





	if (nCurImgType == img_all_load || nCurImgType == img_othersv_no_load){
		imgsh_setShow("da");
	} else if (nCurImgType == img_no_load){
		imgsh_setHide("da");
	}

	document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", imgsh_getContext, false);
	// got this from spellbound;get the contentAreaContextMenu which i am overlaying
	// when the pop up shows, call set context;which checks to see if the node right click
	// is a image
}

function imgsh_abstract_switchimg()
{

	var nCurImgType = m_prefs.getIntPref(img_load_set);
	if (nCurImgType == img_no_load)
	{
		var nCurDefType = m_prefs.getIntPref("imgsh.rldef");
		if(nCurDefType == 0){
			m_prefs.setIntPref(img_load_set, img_all_load);
		}else{
			m_prefs.setIntPref(img_load_set, img_othersv_no_load);
		}
	}
	else if (nCurImgType == img_all_load || nCurImgType == img_othersv_no_load)
	{
		m_prefs.setIntPref(img_load_set, img_no_load);
	}
}


function imgsh_getContext()
{
	if(imgsh_isNodeImage(gContextMenu.target) == 94)
	{
		// check to see if we got an image node
		// bug; what about background-urls
		document.getElementById("imgsh_load_image").hidden = false;
		// got this from spellbound
		// check the xul file for the menu item with id=martha_load
		// it is the load image menu item
		document.getElementById("imgsh_nuke_image").hidden = false;
	}
	else
	{
		document.getElementById("imgsh_load_image").hidden = true;
		document.getElementById("imgsh_nuke_image").hidden = true;
	}
}


function imgsh_isNodeImage(node)
{
	// got this from spell bound
	var nodeName;
	try
	{
		nodeName = node.nodeName.toLowerCase();
	}
	catch(err)
	{
		nodeName = "nada";
	}
	switch(nodeName)
	{
		case "img":
			return 94;
			// secret code
		case "input":
			if(node.getAttribute('type') != null)
			{
				if(node.getAttribute('type').toLowerCase() == 'image')
				{
					return 94;
				}
			}
		default:
			return 10;
	}
}

function imgsh_doLoadImage()
{
	imgNode = gContextMenu.target;
	if(imgNode.src == 'chrome://imgsh/skin/dummy.png'){
		imgsh_doReplaceImage(imgNode);
	}else{
		imgsh_doNukeImage();
		setTimeout('imgsh_doReplaceImage(imgNode)', 500);
	}

}

function imgsh_doNukeImage()
{
	var imgNode = gContextMenu.target;
	if(imgNode.src == 'chrome://imgsh/skin/dummy.png')
	{
		return;








	}


		imgNode.setAttribute('secret', imgNode.getAttribute('src'));
		imgNode.setAttribute('src','chrome://imgsh/skin/dummy.png');
}


function imgsh_doReplaceImage(g)
{

	if(m_prefs.getIntPref(img_load_set) == img_no_load)
	{
		imgsh_abstract_switchimg();
		if(g.getAttribute('secret') != null)
		{
			g.setAttribute('src', g.getAttribute('secret'));
		}
		else
		{
			g.setAttribute("src", g.src);
		}
		imgsh_abstract_switchimg();
	}
	else
	{
		if(g.getAttribute('secret') != null)
		{
			g.setAttribute('src', g.getAttribute('secret'));
		}
	}
}

function imgsh_setShow(danet){
	var nCurDefType = m_prefs.getIntPref("imgsh.rldef");
	if(nCurDefType == 0){
		m_prefs.setIntPref(img_load_set, img_all_load);
	}else{
		m_prefs.setIntPref(img_load_set, img_othersv_no_load);
	}

	var nCurYNType = m_prefs.getIntPref("imgsh.rldyn");
	if ((nCurYNType == 1 || nCurYNType == 3) && danet != "da"){
		window._content.location.reload();
	}

	var sPrefix;
	if (document.getElementById("navigator-toolbox").getAttribute("iconsize")=='small'){
		sPrefix = 'small';
	} else {
		sPrefix = 'big';
	}

	m_button = document.getElementById("imgsh-button");
	m_button.setAttribute('image', 'chrome://imgsh/skin/'+sPrefix+'button.png');
	m_button.setAttribute('tooltiptext', bundle.GetStringFromName("ImgOnTooltip"));
	m_button.setAttribute('label', bundle.GetStringFromName("ImgOnLabel"));
}

function imgsh_setHide(danet){
	m_prefs.setIntPref(img_load_set, img_no_load);
	var nCurYNType = m_prefs.getIntPref("imgsh.rldyn");
	if ((nCurYNType == 2 || nCurYNType == 3) && danet != "da"){
		window._content.location.reload();
	}

	var sPrefix;
	if (document.getElementById("navigator-toolbox").getAttribute("iconsize")=='small'){
		sPrefix = 'small';
	} else {
		sPrefix = 'big';
	}

	m_button = document.getElementById("imgsh-button");
	m_button.setAttribute('image', 'chrome://imgsh/skin/'+sPrefix+'button_gr.png');
	m_button.setAttribute('tooltiptext', bundle.GetStringFromName("ImgOffTooltip"));
	m_button.setAttribute('label', bundle.GetStringFromName("ImgOffLabel"));
}

function chk_pref()
{
	if(nsPreferences.getIntPref("permissions.default.image") == null){
		img_load_set = "network.image.imageBehavior";
		img_all_load = 0;
		img_othersv_no_load = 1;
		img_no_load = 2;
	}
}

